# gamestar.tcl v1.4 by domsen <domsen@domsen.org> (c)2oo3
#
# comments? bugs? ideas? requests? money? beer? 
# plz mail me or visit my homepage @ www.domsen.org
# also check out www.uid-zero.de
#
# das tcl liest die gamestar.de gaming news aus und gibt sie wieder, gleich mit
# dem link zum eigentlichen artikel. per trigger lassen sich auch die letzten X
# news von hand auslesen.
#
# v1.4 - komplett umgebaut by public request
#      - link wird gleich mitgepostet
#      - yeah  endlich  keine  windrop  user  mehr die mich fragen was lynx ist
#        so gerne ich support leiste - jeden tag ne  mail mit der  selben frage
#        stresst ziemlich ;)
#
# gstrigger - der trigger auf den der bot reagiert (public und message)
# gamestarlimit - maximum der news die auf befehl geposted werden
# gsnewspost  - 1 fr newsposting, 0 fr keines
# gamestarchans  - die  chans in  denen das tcl aktiv  ist, "" fr alle
# gamestarnewspostlimit - maximum der news die geposted werden
# isgamestarhub  - legt fest ob der bot newshub ist oder nicht
# gamestarleafs  - die nicks der leafbots auf denen das leaf tcl luft
#
####### config ######################

set gstrigger ".gamestar"
set gamestarchans ""
set gamestarlimit "5"
set gamestarnewspostlimit "3"
set gsnewspost "1"
set isgamestarhub "0"
set gamestarleafs ""

####### ende der config #############

bind msg - $gstrigger msg_gs
bind pub - $gstrigger pub_gs
bind time - "?0 * * * *" gscheck

proc sendgamestarnews { arg } {
global gamestarleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $gamestarleafs] [string tolower $bot]] != -1)} {
putbot $bot "gamestar: $arg"
}}}

proc shrink { calc number string start bl} { return [expr [string first "$string" $bl $start] $calc $number] }

proc gamestarnews { target limit } {
if {[catch {set sock [socket www.gamestar.de 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /default.htm  HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.gamestar.de"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "class=\"newsliste\">" $bl] != -1 && [string first "Viele weitere aktuelle News" $bl] == -1 } {
set link [string range $bl 12 [shrink - 2 " class=\"newsliste\"" 0 $bl]]
set newsline [string range $bl [shrink + 18 "class=\"newsliste\">" 0 $bl] [shrink - 1 "</a>" 0 $bl]]
putserv "privmsg $target :[incr counter] $newsline <$link>"
}
if {$counter == $limit} {close $sock; return 0}
}}}


proc gscheck {nick uhost hand chan arg} {
global gamestarchans gsnewspost isgamestarhub gamestarnewspostlimit
set counter 0
if {$gsnewspost == 1 } {
putlog "gamestar: suche nach neuer newsline"
set gslastnews "none"
if {[file exists gamestar.hdl]} {
set temp [open "gamestar.hdl" r]
set gslastnews "[gets $temp]"
if {$gslastnews == "" } { set gslastnews "none" }
close $temp
}
set temp [open "gamestar.hdl" w+]
if {[catch {set sock [socket www.gamestar.de 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /default.htm  HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.gamestar.de"
puts $sock "Connection: close"
puts $sock ""
flush $sock
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "class=\"newsliste\">" $bl] != -1 && [string first "Viele weitere aktuelle News" $bl] == -1 } {
set link [string range $bl 12 [shrink - 2 " class=\"newsliste\"" 0 $bl]]
set newsline [string range $bl [shrink + 18 "class=\"newsliste\">" 0 $bl] [shrink - 1 "</a>" 0 $bl]]
puts $temp "$newsline <$link>"
}}}
close $sock ; close $temp
if {$gslastnews == "none" } { putlog "gamestar: headlinefile created" ; return 0 }
set temp [open "gamestar.hdl" r]
while { [eof $temp] != 1 } {
set gsneunews [gets $temp]
if {($gslastnews == $gsneunews) || ($counter == $gamestarnewspostlimit)} { close $temp;return 0 }
if { $isgamestarhub == 1 } {sendgamestarnews $gsneunews}
incr counter
foreach chan [channels] {
if {$gamestarchans == "" } { putserv "privmsg $chan :(neue gamestar newsline) $gsneunews" }
if {$gamestarchans != "" } {
if {([lsearch -exact [string tolower $gamestarchans] [string tolower $chan]] != -1) || ($gamestarchans == "")} {putserv "privmsg $chan :(neue gamestar newsline) $gsneunews"}
}
}}}}


proc msg_gs { nick uhost hand arg } { global gamestarlimit ; gamestarnews $nick $gamestarlimit }
proc pub_gs { nick uhost hand chan arg } { global gamestarchans gamestarlimit ; if {([lsearch -exact [string tolower $gamestarchans] [string tolower $chan]] != -1) || ($gamestarchans == "")} { gamestarnews $nick $gamestarlimit }}


putlog "*** gamestar.tcl v1.4 by domsen <domsen@domsen.org> succesfully loaded"

#[EOF]
